package jp.dip.commonsense.android.mametalk;

import jp.dip.commonsense.tooldroid.commons.StringUtils;
import android.database.Cursor;
import android.graphics.Color;
import android.provider.Im.BaseMessageColumns;
import android.provider.Im.MessageType;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;

public class ChatClient extends AbstractChatActivity {

    @Override
    protected void fillData() {
        Cursor cursor = managedQuery(getIntent().getData(), null, null, null);
        this.setListAdapter(new SimpleCursorAdapter(this, R.layout.message_list_item, cursor,
            new String[] { BaseMessageColumns.TYPE, BaseMessageColumns.BODY }, new int[] {
                R.id.message_type_text, R.id.message_body_text }) {
            @Override
            public void setViewText(TextView v, String text) {
                String disp = text;
                if (v.getId() == R.id.message_type_text) {
                    switch (Integer.valueOf(disp)) {
                    case MessageType.OUTGOING:
                        disp = "";
                        break;
                    case MessageType.INCOMING:
                        disp = "> ";
                        break;
                    case MessageType.PRESENCE_AVAILABLE:
                        disp = StringUtils.createPreparedText(getString(R.string.info_online),
                            contactName);
                        break;
                    case MessageType.PRESENCE_AWAY:
                        disp = StringUtils.createPreparedText(getString(R.string.info_away),
                            contactName);
                        break;
                    case MessageType.PRESENCE_DND:
                        disp = StringUtils.createPreparedText(getString(R.string.info_busy),
                            contactName);
                        break;
                    case MessageType.PRESENCE_UNAVAILABLE:
                        disp = StringUtils.createPreparedText(getString(R.string.info_offline),
                            contactName);
                        break;
                    }
                    v.setTextColor(Color.GRAY);
                }
                super.setViewText(v, disp);
            }
        });
    }
}
